<?php
/**
 * 苏宁订单处理
 *
 * @category 
 * @package 
 * @author chenping<chenping@shopex.cn>
 * @version $Id: Z
 */
class erpapi_shop_matrix_shopex_fxw_response_order extends erpapi_shop_matrix_shopex_response_order
{
    public function business_flow($sdf)
    {
        if ($sdf['t_type'] == 'fenxiao' || $sdf['order_source'] == 'taofenxiao') {
            $order_type = 'b2b';
        } else {
            $order_type = 'b2c';
        }

        return kernel::single('erpapi_shop_matrix_shopex_fxw_response_order_'.$order_type);
    }


    protected function _analysis()
    {
        parent::_analysis();

 
        // 重新计算优惠，兼容分销王将商品优惠，打在订单优惠上
        // 验证订单金额是否正确
        $total_amount = (float) $this->_ordersdf['cost_item'] 
                                + (float) $this->_ordersdf['shipping']['cost_shipping'] 
                                + (float) $this->_ordersdf['shipping']['cost_protect'] 
                                + (float) $this->_ordersdf['discount'] 
                                + (float) $this->_ordersdf['cost_tax'] 
                                + (float) $this->_ordersdf['payinfo']['cost_payment'] 
                                - (float) $this->_ordersdf['pmt_goods'] 
                                - (float) $this->_ordersdf['pmt_order'];
        if(0 != bccomp($total_amount, $this->_ordersdf['total_amount'],3)){
            $pmt_goods = $cost_item = 0;
            foreach ($this->_ordersdf['order_objects'] as $objkey => $object){
                foreach ($object['order_items'] as $itemkey => $item){
                    $amount = (float) $item['price'] * $item['quantity'];
                    $pmt_price = $amount - (float) $item['sale_price'];
                    $pmt_goods += $pmt_price;
                    $cost_item += (float) $item['sale_price'];

                    // 判断优惠金额是否被记录
                    if(0 != bccomp($item['pmt_price'], $pmt_price,3)){
                        $this->_ordersdf['order_objects'][$objkey]['order_items'][$itemkey]['pmt_price'] = (string) $pmt_price;
                        //echo 1;exit;
                    }
                }
            }
            if(0 == bccomp($pmt_goods, 0,3)){
                // 去除订单优惠的总额
                $total_amount = (float) $this->_ordersdf['cost_item'] 
                                        + (float) $this->_ordersdf['shipping']['cost_shipping'] 
                                        + (float) $this->_ordersdf['shipping']['cost_protect'] 
                                        + (float) $this->_ordersdf['discount'] 
                                        + (float) $this->_ordersdf['cost_tax'] 
                                        + (float) $this->_ordersdf['payinfo']['cost_payment'] 
                                        - (float) $this->_ordersdf['pmt_goods'];
                if(0 == bccomp($total_amount, $this->_ordersdf['total_amount'],3) && 0 != bccomp($this->_ordersdf['pmt_order'], 0,3)){
                    // 订单优惠置0
                    $this->_ordersdf['pmt_order'] = '0';//echo 2;exit;
                    return true;
                }
                return true;
            }

            // 如果从订单优惠中除去商品优惠后，总金额匹配，进行数据修复
            $pmt_order = (float) $this->_ordersdf['pmt_order'] - $pmt_goods;
            $pmt_order = $pmt_order > 0 ? $pmt_order : 0;
            $total_amount = (float) $this->_ordersdf['cost_item'] 
                                    + (float) $this->_ordersdf['shipping']['cost_shipping'] 
                                    + (float) $this->_ordersdf['shipping']['cost_protect'] 
                                    + (float) $this->_ordersdf['discount'] 
                                    + (float) $this->_ordersdf['cost_tax'] 
                                    + (float) $this->_ordersdf['payinfo']['cost_payment'] 
                                    - (float) $this->_ordersdf['pmt_goods']
                                    - $pmt_order;
            if( 0 == bccomp($total_amount, $this->_ordersdf['total_amount'],3)){
                $this->_ordersdf['pmt_order'] = (string) $pmt_order;
                
                // 判断商品总金额是否是扣除商品优惠后的金额
                if(0 == bccomp($cost_item, $this->_ordersdf['cost_item'],3)){
                    $this->_ordersdf['cost_item'] += $pmt_goods;
                    $this->_ordersdf['pmt_goods'] += $pmt_goods;//echo 3;exit;

                    $this->_ordersdf['cost_item'] = (string) $this->_ordersdf['cost_item'];
                    $this->_ordersdf['pmt_goods'] = (string) $this->_ordersdf['pmt_goods'];
                }
            }
        } else {
            // 重新计算优惠金额
            $pmt_goods = $cost_item = 0;
            foreach ($this->_ordersdf['order_objects'] as $objkey => $object){
                foreach ($object['order_items'] as $itemkey => $item){
                    $cost_item += (float) $item['sale_price'];

                    $amount = (float) $item['price'] * $item['quantity'];
                    $pmt_price = $amount - (float) $item['sale_price'];
                    if(1 != bccomp($pmt_price, 0,3)){
                        continue;
                    }
                    $pmt_goods += $pmt_price;

                    // 判断优惠金额是否被记录
                    if(0 == bccomp($item['pmt_price'], 0,3)){
                        $this->_ordersdf['order_objects'][$objkey]['order_items'][$itemkey]['pmt_price'] = (string) $pmt_price;

                    }
                }
            }

            // 重新计算商品总额
            if(0 == bccomp($this->_ordersdf['pmt_goods'], 0,3) 
                && 0 == bccomp($this->_ordersdf['cost_item'], $cost_item,3)
                && 1 == bccomp($pmt_goods, 0,3)){

                $this->_ordersdf['cost_item'] += $pmt_goods;
                $this->_ordersdf['pmt_goods'] += $pmt_goods;//echo 3;exit;

                $this->_ordersdf['cost_item'] = (string) $this->_ordersdf['cost_item'];
                $this->_ordersdf['pmt_goods'] = (string) $this->_ordersdf['pmt_goods'];
            }
        }
    }

    protected function _operationSel()
    {
        parent::_operationSel();

        // 为下代码为兼容，客户支付后打过来的更新时间小于创建时间
        if (empty($this->_operationSel) 
            && $this->_tgOrder
            && $this->_tgOrder['pay_status'] == '0'
            && $this->_ordersdf['pay_status'] == '1'
            && $this->_ordersdf['payments']) {
                $this->_operationSel = 'update';
        }
    }

    protected function get_create_plugins()
    {
        $plugins = parent::get_create_plugins();

        $plugins[] = 'fxw';
        $plugins[] = 'sellingagent';

        return $plugins;
    }

    protected function get_update_plugins()
    {
        $plugins = parent::get_update_plugins();

        
        $plugins[] = 'sellingagent';
        
        return $plugins;
    }
}
