<?php
/**
 * 
 *
 * @category 
 * @package 
 * @author chenping<chenping@shopex.cn>
 * @version $Id: Z
 */
class erpapi_shop_matrix_shopex_fxw_response_order_b2b extends erpapi_shop_matrix_shopex_fxw_response_order
{   
    protected $_update_accept_dead_order = true;

    protected function _analysis()
    {
        parent::_analysis();


        if ($this->__channelObj->get_ver() > 1) {
            $this->mergeItemsForB2b();
        }
    }

    /**
     * 淘分销订单，相同货号，类型，价格的订单明细合并
     *
     * @return void
     * @author 
     **/
    private function mergeItemsForB2b()
    {
        foreach ($this->_ordersdf['order_objects'] as $objkey => $object) {
            if (!$object['bn']) continue;

            $obj_type = $object['obj_type'] ? $object['obj_type'] : 'goods';

            $ident = sprintf('%u',crc32($object['bn'] . '-' . $obj_type));

            $order_items = array(); $replace = false;
            foreach ($object['order_items'] as $item) {
                $item_type = $item['item_type'] ? $item['item_type'] : 'product';

                // 销售单价
                $quantity = $item['quantity'] ? $item['quantity'] : 1;
                $subtotal = $item['amount'] ? $item['amount'] : bcmul((float)$item['price'], $quantity,3);
                $sale_price = $item['sale_price'] ? (float)$item['sale_price'] : bcsub($subtotal, (float)$item['pmt_price'],3);

                $unit_sale_price = bcdiv((float)$sale_price, $quantity,3);


                $itemkey = sprintf('%u',crc32($item['bn'] . '-' . $item_type . $unit_sale_price));

                if (isset($order_items[$itemkey])) { // 如果存在，说明有合并
                    // 各相关值叠加
                    $order_items[$itemkey]['quantity']   += $item['quantity'];
                    $order_items[$itemkey]['pmt_price']  += $item['pmt_price'];
                    $order_items[$itemkey]['price']      += $item['price'];
                    $order_items[$itemkey]['amount']     += $item['amount'];
                    $order_items[$itemkey]['sale_price'] += $item['sale_price'];

                    $replace = true;

                } else {
                    $order_items[$itemkey] = $item;
                }
            }

            if ($replace === true) {
                $this->_ordersdf['order_objects'][$objkey]['order_items'] = $order_items;

                // 订单obj明细唯一标识
                $this->object_comp_key = 'bn-oid-obj_type';

                // 订单item唯一标识
                $this->item_comp_key = 'bn-unit_sale_price-item_type';         
            }
        }
    }
}
