<?php
/**
 * 发货单处理
 *
 * @category 
 * @package 
 * @author chenping<chenping@shopex.cn>
 * @version $Id: Z
 */
class erpapi_shop_matrix_tmall_request_delivery extends erpapi_shop_request_delivery
{
    protected function get_delivery_apiname($sdf)
    {
        if($sdf['is_virtual']) { //虚拟发货
            return SHOP_LOGISTICS_DUMMY_SEND;
        }
        // 如果开启了线上发货
        if ('on' == app::get('ome')->getConf('ome.delivery.method') && $sdf['orderinfo']['sync'] == 'none') {
            $api_name = SHOP_LOGISTICS_ONLINE_SEND;
        } else {
            $api_name = $sdf['orderinfo']['is_cod'] == 'true' ? SHOP_LOGISTICS_ONLINE_SEND : SHOP_LOGISTICS_OFFLINE_SEND;
        }
        
        // 如果是家装，调用家装接口
        if ($sdf['jzpartner']) {
            $api_name = SHOP_WLB_ORDER_JZWITHINS_CONSIGN;
        }

        return $api_name;
    }

    /**
     * 发货请求参数
     *
     * @return void
     * @author 
     **/
    protected function get_confirm_params($sdf)
    {
        if ($sdf['jzpartner']) {// 家装参数
            $tms_partner = array(
                'tp_code'       => $sdf['jzpartner']['tp_code'],
                'tp_name'       => $sdf['jzpartner']['tp_name'],
                'service_type'  => $sdf['jzpartner']['service_type'],
                'is_virtual_tp' => $sdf['jzpartner']['is_virtual_tp'],
            );
            $jz_consign_args = array(
                'mail_no'         => $sdf['logi_no'],
                'package_remark'  => '',
                'zy_mail_no'      => $sdf['logi_no'],
                'zy_company'      => $sdf['logi_name'],
                'zy_phone_number' => $this->__channelObj->channel['mobile'] ? $this->__channelObj->channel['mobile'] : $this->__channelObj->channel['tel'],
                'zy_consign_time' => date('Y-m-d',$sdf['delivery_time']),
            );

            $param = array(
                'tid'             =>$sdf['orderinfo']['order_bn'],
                'tms_partner'     => json_encode($tms_partner),
                'jz_consign_args' => json_encode($jz_consign_args),
            );
        } else {
            $param = parent::get_confirm_params($sdf);
            
            // 拆单子单回写
            if($sdf['is_split'] == 1) {
                $param['is_split']  = $sdf['is_split'];
                $param['oid_list']  = implode(',',$sdf['oid_list']);
            }

            // 判断是否开启唯一码回写
            if ($sdf['feature']) $param['feature'] = $sdf['feature'];
        }

        return $param;
    }

    /**
     * 数据处理
     *
     * @return void
     * @author 
     **/
    protected function format_confirm_sdf(&$sdf)
    {
        parent::format_confirm_sdf($sdf);

        // 如果是家装
        if ('1' == app::get('ome')->getConf('shop.jzorder.config.'.$this->__channelObj->channel['shop_id'])) {
            $partner = $this->jzpartner_query($sdf);

            if ($partner) {
                $sdf['jzpartner'] = array(
                    'tp_code'       => $partner['tp_code'],
                    'tp_name'       => $partner['tp_name'],
                    'service_type'  => $partner['service_type'],
                    'is_virtual_tp' => $partner['is_virtual_tp'],
                );
            }
        }
    }
}