<?php
/**
 * @desc
 * @author: jintao
 * @since: 2016/7/20
 */
class erpapi_shop_matrix_tmall_response_aftersalev2 extends erpapi_shop_response_aftersalev2 {

    protected function _formatAddParams($params) {
        if (($params['spider_type'] == 'tm_refund') || ($params['spider_type'] != 'tm_refund_i')) {
            $this->__apilog['result']['msg'] = '天猫售后老接口数据，不接受';
            return array();
        }
        $sdf = parent::_formatAddParams($params);
        $item = current($sdf['refund_item_list']['return_item']);
        if($params['tag_list']) {
            $tagList = json_decode($params['tag_list'], true);
            $tagList = serialize($tagList);
        }
        $tmallSdf = array(
            'oid'               => $params['oid'] ? $params['oid'] : $item['oid'],
            'refund_phase'      => $params['refund_phase'] ? $params['refund_phase'] : $item['refund_phase'],
            'cs_status'         => $params['cs_status'],
            'advance_status'    => $params['advance_status'],
            'split_taobao_fee'  => $params['split_taobao_fee'],
            'split_seller_fee'  => $params['split_seller_fee'],
            'total_fee'         => $params['total_fee'],
            'seller_nick'       => $params['seller_nick'],
            'good_status'       => $params['good_status'],
            'current_phase_timeout'=>strtotime($params['current_phase_timeout']),
            'ship_addr'         => $params['receiver_address'],
            'tag_list'          => $tagList ? $tagList : '',
            'address'           => $params['address'] ? $params['address'] : '',
            'shipping_type'   => $params['shipping_type'],
            'buyer_nick'      => $params['buyer_nick'],
            'has_good_return' => $params['has_good_return'],
            'good_return_time'=> $params['good_return_time'],
            'refund_type'     => $params['refund_type'],
            'tmall_refund_type'     => $params['refund_type'],
            'refund_version'  => $params['refund_version'],
            'alipay_no'       => $params['payment_id'],
            'trade_status'      =>$params['trade_status'],
            'bill_type'       => $params['bill_type'],
            't_ready'         =>$sdf['created'],
            't_sent'          =>$sdf['modified'],
            't_received'      =>''
        );
        return array_merge($sdf, $tmallSdf);
    }

    protected function _getAddType($sdf) {
        if ($sdf['refund_type'] == 'return') {
            if (in_array($sdf['order']['ship_status'],array('0'))) {
                #退款单
                return 'refund';
            }else{
                #退货申请单
                return 'returnProduct';
            }
        }elseif($sdf['refund_type'] == 'reship'){
            #退货单
            return 'reship';
        }else{
            #退款单
            return 'refund';
        }
    }

    protected function _formatAddItemList($sdf, $convert = array()) {
        if($sdf['refund_type'] == 'reship') {
            return array();
        }
        $convert = array(
            'sdf_field'=>'oid',
            'order_field'=>'oid',
            'default_field'=>'outer_id'
        );
        return parent::_formatAddItemList($sdf, $convert);
    }

    protected function _refundApplyAdditional($sdf) {
        $ret = array(
            'model' => 'refund_apply_tmall',
            'data' => array(
                'shop_id'           => $sdf['shop_id'],
                'shipping_type'     => $sdf['shipping_type'],
                'cs_status'         => $sdf['cs_status'],
                'advance_status'    => $sdf['advance_status'],
                'split_taobao_fee'  => $sdf['split_taobao_fee'],
                'split_seller_fee'  => $sdf['split_seller_fee'],
                'total_fee'         => $sdf['total_fee'],
                'buyer_nick'        => $sdf['buyer_nick'],
                'seller_nick'       => $sdf['seller_nick'],
                'good_status'       => $sdf['good_status'],
                'has_good_return'   => $sdf['has_good_return'],
                'good_return_time'  => $sdf['good_return_time'],
                'oid'               => $sdf['oid'],
                'refund_version'    => $sdf['refund_version'],
                'bill_type'         => $sdf['bill_type'],
                'outer_lastmodify'  => $sdf['modified'],
                'alipay_no'         => $sdf['alipay_no'],
                'current_phase_timeout'=>$sdf['current_phase_timeout'],
                'refund_type'       => $sdf['tmall_refund_type'] ? $sdf['tmall_refund_type'] : '',
                'refund_phase'      => $sdf['refund_phase'] ? $sdf['refund_phase'] : '',
                'tag_list'          => $sdf['tag_list']
            )
        );
        return $ret;
    }

    protected function _refundAddSdf($sdf){
        $sdf['shop_type'] = 'tmall';

        if(self::$refund_status[strtoupper($sdf['status'])] != '4') {
            $sdf['refund_type'] = 'apply';
        }
        $sdf = parent::_refundAddSdf($sdf);
        if($sdf['refund_apply']) {
            $oRefundTmall = app::get('ome')->model('refund_apply_tmall');
            $refundTmallData = $oRefundTmall->getList('refund_version', array('apply_id'=>$sdf['refund_apply']['apply_id'],'shop_id'=>$sdf['shop_id']), 0, 1);
            if ($sdf['refund_version'] > $refundTmallData[0]['refund_version']) {
                $sdf['refund_version_change'] = true;
                $sdf['table_additional'] = $this->_refundApplyAdditional($sdf);
            }
        }
        return $sdf;
    }

    protected function _returnProductAdditional($sdf) {
        $ret = array(
            'model' => 'return_product_tmall',
            'data' => array(
                'shop_id'         => $sdf['shop_id'],
                'shipping_type'   => $sdf['shipping_type'],
                'cs_status'       => $sdf['cs_status'],
                'advance_status'  => $sdf['advance_status'],
                'split_taobao_fee'=> $sdf['split_taobao_fee'],
                'split_seller_fee'=> $sdf['split_seller_fee'],
                'total_fee'       => $sdf['total_fee'],
                'buyer_nick'      => $sdf['buyer_nick'],
                'seller_nick'     => $sdf['seller_nick'],
                'good_status'     => $sdf['good_status'],
                'has_good_return' => $sdf['has_good_return'],
                'good_return_time'=> $sdf['good_return_time'],
                'refund_type'     => $sdf['refund_type'],
                'refund_phase'    => $sdf['refund_phase'],
                'refund_version'  => $sdf['refund_version'],
                'alipay_no'       => $sdf['alipay_no'],
                'trade_status'    => $sdf['trade_status'],
                'oid'             => $sdf['oid'],
                'bill_type'       => $sdf['bill_type'],
                'current_phase_timeout'=>$sdf['current_phase_timeout'],
                'tag_list'        => $sdf['tag_list'],
                'address'         => $sdf['address']
            )
        );
        return $ret;
    }

    protected function _returnProductAddSdf($sdf) {
        $sdf['shop_type'] = 'tmall';
        $sdf = parent::_returnProductAddSdf($sdf);
        if(!$sdf) {
            return false;
        }
        $sdf['choose_type_flag'] = 0;
        if($sdf['return_product']) {
            $oRefundTmall = app::get('ome')->model('return_product_tmall');
            $refundTmallData = $oRefundTmall->getList('refund_version', array('apply_id'=>$sdf['refund_apply']['apply_id'],'shop_id'=>$sdf['shop_id']), 0, 1);
            if ($sdf['refund_version'] > $refundTmallData[0]['refund_version']) {
                $sdf['refund_version_change'] = true;
            }
        }
        $sdf['table_additional'] = $this->_returnProductAdditional($sdf);
        return $sdf;
    }
}